function loadTable() {
	
	var tableContent = document.getElementById("tableContent");
	type = sessionStorage.getItem('direction');
	//preparing HTML template to be filled with JSON
	tableContent.innerHTML = ''+ 
	'<thead>'+
		'<tr id="columns">'+																										
		'</tr>'+
	'</thead>'+
	'<tbody id="data">'+	
	'</tbody>';
	
	//loading JSON data
	
	
	getDataRequest(type);
	//var xhr = new XMLHttpRequest();
	//xhr.open('POST', userServicePath + '/signin');

	//var userLogin = document.getElementById('login').value;
	//var userPassword = document.getElementById('password').value;
	//var JSONdata = {};
	//JSONdata.login = userLogin;
	//JSONdata.password = userPassword;
	//var JSONarray = new Array();
	//JSONarray[0] = JSONdata;

	//xhr.onload = function () {
	//    //insertData(xhr.responseText);
	//    sessionStorage.setItem('login', userLogin);
	//    sessionStorage.setItem('UUID', xhr.responseText);
	//    window.location.href = userServicePath + "/index.html";
	//};

	//xhr.send(JSON.stringify(JSONarray));
}
function loadData(rawJSON){	 
	
	var data = JSON.parse(rawJSON);
	
	//columns loading
	var columns = document.getElementById("columns");
	var countColumns =0;
	for(var columnTitle in data[0]){
			nodeTh = document.createElement("th");			
			textnode = document.createTextNode(columnTitle);         
			nodeTh.appendChild(textnode);			
			columns.appendChild(nodeTh);	
			countColumns++;			
	}	
	
	//table content loading	
	var table = document.getElementById("data");
	for(var row in data){
		var nodeTr = document.createElement("tr"); 
		var nodeTd = document.createElement("td");		
		var textnode = document.createTextNode(row);				
		for(var field in data[row]){
			nodeTd = document.createElement("td");	
			//textnode = document.createTextNode(data[row][field]); 
			nodeTd.innerHTML = '<input type="text" name="demo-name" id="demo-name" style="border-bottom: none" value="'+data[row][field]+'"  required />'				
			nodeTr.appendChild(nodeTd);
			nodeTr.id = data[row]['id'];		
		}	
		
		//edit button
		nodeTd = document.createElement("td");		
		nodeTd.innerHTML = '<a onclick="editRow('+data[row]['id']+')" class="icon style2 fa-edit" title="Edit"><span class="label">Edit</span></a>';
		nodeTr.appendChild(nodeTd);			
		table.appendChild(nodeTr);	
		
		//delete button
		nodeTd = document.createElement("td");		
		nodeTd.innerHTML = '<a onclick="removeRow('+data[row]['id']+')" class="icon style2 fa-remove" title="Remove"><span class="label">Remove</span></a>';
		nodeTr.appendChild(nodeTd);			
		table.appendChild(nodeTr);						
	}
	
	//adding row - inputs
	var addRow = document.createElement("tr");
	addRow.id = "addRow";
	var addTd = document.createElement("td");
	addRow.appendChild(addTd);
	for(i=1; i<countColumns; i++){	//avoiding first column (ID)
		addTd = document.createElement("td");
		addTd.innerHTML = ''+
			'<input type="text" name="demo-name" id="demo-name" value=""  required />';
		addRow.appendChild(addTd);
	}
	
	//empty cell button
		addTd = document.createElement("td");		
		addTd.innerHTML = '';
		addRow.appendChild(addTd);			
		table.appendChild(addRow);	
		
	//adding - button
	addTd = document.createElement("td");
	addTd.innerHTML = ''+
		'<a onclick="addData()" class="icon style2 fa-plus" title="Add"><span class="label">Add</span></a>';
	addRow.appendChild(addTd);
	table.appendChild(addRow);
}
function insertData(JSONstring){
	var data = JSON.parse(JSONstring);	
	
	var table = document.getElementById("data");
	
	//inserting ID field
	var nodeTr = document.createElement("tr"); 
	var nodeTd = document.createElement("td");	
	var ID = 0;	 //will be generated by database;	
	nodeTd.innerText = ID;
	nodeTr.appendChild(nodeTd);
	nodeTr.id = ID;

	//inserting the rest of fields
	for(var field in data){
		nodeTd = document.createElement("td");		
		textnode = document.createTextNode(data[field]);         
		nodeTd.appendChild(textnode);
		nodeTr.appendChild(nodeTd);	
	}	
	
	//remove button
	nodeTd = document.createElement("td");		 
	nodeTd.innerHTML = '' +
		'<a onclick="removeRow('+ID+')" class="icon style2 fa-remove" title="Remove"><span class="label">Remove</span></a>';
	nodeTr.appendChild(nodeTd);	
	
	//inserting before adding row
	table.insertBefore(nodeTr, table.lastChild); 	
}

function addData(){
	
	//preparing JSON data
	var columns = document.getElementById("columns").children;
	var JSONdata = {};
	var i = 0;
	var inputFileds = document.getElementById("addRow");	
	for(var columnNumber in columns) {
		
		if (i !== 0 && i< columns.length) {			
			JSONdata[columns[columnNumber].innerText] = inputFileds.children[columnNumber].firstChild.value;
		}
		i++;	
	}
	var JSONcollection = {};
	JSONcollection[0] = JSONdata;
	var JSONstring = JSON.stringify(JSONdata);

	var xhr = new XMLHttpRequest();
	xhr.open('POST', servicePath + '/' + type + '/insert');
	xhr.setRequestHeader('Authorization', sessionStorage.getItem('UUID'));
	xhr.onload = function () {
		//insertData(xhr.responseText);
		//xhr.responseType == success?
		loadTable();
	};

	xhr.send(JsonToOneElementArray(JSONstring));
	
	//inserting JSON into table
	
}

function editRow(rowID){
	
	//preparing JSON data
	var columnNames = document.getElementById("columns").children;
	var columns = document.getElementById(rowID).children;
	var JSONdata = {};
	var i = 0;
	
	for(var columnNumber in columns) {		
		var input = columns[columnNumber].firstChild;
		if( i < columns.length - 2 ){			
			JSONdata[columnNames[columnNumber].innerText] = input.value;
		}
		i++;	
	}
	var JSONcollection = {};
	JSONcollection[0] = JSONdata;
	var JSONstring = JSON.stringify(JSONdata);

	var xhr = new XMLHttpRequest();
	xhr.open('POST', servicePath + '/' + type + '/update');
	xhr.setRequestHeader('Authorization', sessionStorage.getItem('UUID'));
	xhr.onload = function () {
		//insertData(xhr.responseText);
		//xhr.responseType == success?
		loadTable();
	};

	xhr.send(JsonToOneElementArray(JSONstring));
	
	//inserting JSON into table
	
}

function removeRow(rowID)
{
	var xhr = new XMLHttpRequest();
	xhr.open('GET', servicePath + '/' + type + '/delete/' + rowID);
	xhr.setRequestHeader('Authorization', sessionStorage.getItem('UUID'));
	xhr.onload = function () {
		var result = xhr.status;
		loadTable();
	};

	xhr.send(rowID);
	//var row = document.getElementById(rowID);
	//row.remove();
}

function getDataRequest(type){
	var xhr = new XMLHttpRequest();
	xhr.open('GET', servicePath +'/'+type+'/select');
	xhr.setRequestHeader('Authorization', sessionStorage.getItem('UUID'));
	xhr.onload = function () {
		loadData(xhr.responseText);
	};
	xhr.send();
}
function JsonToOneElementArray(JSONstring)
{
	return '[' + JSONstring + ']';
}